#ifndef _TLHELP32_H
#define _TLHELP32_H

#if __POCC__ >= 500
#pragma once
#endif

/* Windows Tool Help definitions (Pocket PC, Smartphone) */

#if defined(WINCE_DEFAULT_LIBS)
#pragma comment(lib, "toolhelp.lib")
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define TH32CS_SNAPHEAPLIST  0x00000001
#define TH32CS_SNAPPROCESS  0x00000002
#define TH32CS_SNAPTHREAD  0x00000004
#define TH32CS_SNAPMODULE  0x00000008
#define TH32CS_SNAPNOHEAPS  0x40000000
#define TH32CS_SNAPALL  (TH32CS_SNAPHEAPLIST|TH32CS_SNAPPROCESS|TH32CS_SNAPTHREAD|TH32CS_SNAPMODULE)
#define TH32CS_GETALLMODS  0x80000000

#define HF32_DEFAULT  1

#define LF32_FIXED  0x00000001
#define LF32_FREE  0x00000002
#define LF32_MOVEABLE  0x00000004
#define LF32_DECOMMIT  0x00000008
#define LF32_BIGBLOCK  0x00000010

typedef struct tagHEAPLIST32 {
    DWORD dwSize;
    DWORD th32ProcessID;
    DWORD th32HeapID;
    DWORD dwFlags;
} HEAPLIST32, *PHEAPLIST32, *LPHEAPLIST32;

typedef struct tagHEAPENTRY32 {
    DWORD dwSize;
    HANDLE hHandle;
    DWORD dwAddress;
    DWORD dwBlockSize;
    DWORD dwFlags;
    DWORD dwLockCount;
    DWORD dwResvd;
    DWORD th32ProcessID;
    DWORD th32HeapID;
} HEAPENTRY32, *PHEAPENTRY32, *LPHEAPENTRY32;

typedef struct tagPROCESSENTRY32 {
    DWORD dwSize;
    DWORD cntUsage;
    DWORD th32ProcessID;
    DWORD th32DefaultHeapID;
    DWORD th32ModuleID;
    DWORD cntThreads;
    DWORD th32ParentProcessID;
    LONG pcPriClassBase;
    DWORD dwFlags;
    TCHAR szExeFile[MAX_PATH];
    DWORD th32MemoryBase;
    DWORD th32AccessKey;
} PROCESSENTRY32, *PPROCESSENTRY32, *LPPROCESSENTRY32;

typedef struct tagTHREADENTRY32 {
    DWORD dwSize;
    DWORD cntUsage;
    DWORD th32ThreadID;
    DWORD th32OwnerProcessID;
    LONG tpBasePri;
    LONG tpDeltaPri;
    DWORD dwFlags;
    DWORD th32AccessKey;
    DWORD th32CurrentProcessID;
} THREADENTRY32, *PTHREADENTRY32, *LPTHREADENTRY32;

typedef struct tagMODULEENTRY32 {
    DWORD dwSize;
    DWORD th32ModuleID;
    DWORD th32ProcessID;
    DWORD GlblcntUsage;
    DWORD ProccntUsage;
    BYTE *modBaseAddr;
    DWORD modBaseSize;
    HMODULE hModule;
    TCHAR szModule[MAX_PATH];
    TCHAR szExePath[MAX_PATH];
    DWORD dwFlags;
} MODULEENTRY32, *PMODULEENTRY32, *LPMODULEENTRY32;

HANDLE WINAPI CreateToolhelp32Snapshot(DWORD, DWORD);
BOOL WINAPI CloseToolhelp32Snapshot(HANDLE);
BOOL WINAPI Heap32ListFirst(HANDLE, LPHEAPLIST32);
BOOL WINAPI Heap32ListNext(HANDLE, LPHEAPLIST32);
BOOL WINAPI Heap32First(HANDLE, LPHEAPENTRY32, DWORD, DWORD);
BOOL WINAPI Heap32Next(HANDLE, LPHEAPENTRY32);
BOOL WINAPI Toolhelp32ReadProcessMemory(DWORD, LPCVOID, LPVOID, DWORD, LPDWORD);
BOOL WINAPI Process32First(HANDLE, LPPROCESSENTRY32);
BOOL WINAPI Process32Next(HANDLE, LPPROCESSENTRY32);
BOOL WINAPI Thread32First(HANDLE, LPTHREADENTRY32);
BOOL WINAPI Thread32Next(HANDLE, LPTHREADENTRY32);
BOOL WINAPI Module32First(HANDLE, LPMODULEENTRY32);
BOOL WINAPI Module32Next(HANDLE, LPMODULEENTRY32);

#ifdef __cplusplus
}
#endif

#endif /* _TLHELP32_H */
